#include "gloobus-preview-interface-text.h"

//============================= END =========================================== //
void iText::end()
{

}
// ========================= CONSTRUCTOR ================================= //
void iText::load(void)
{
	g_print("Loading Text...\n");
	//m_textbuf = get_textbuf();
	m_sBuf = get_textbuf();
	
	/*
	
	GtkSourceLanguageManager *lm;
  	GtkSourceLanguage *language = NULL;


	//sView = gtk_source_view_new_with_buffer(sBuf);
	lm 			= gtk_source_language_manager_new();
	language 	= gtk_source_language_manager_guess_language (lm,m_filename.c_str(),NULL);
	m_sBuf 		= gtk_source_buffer_new(NULL);
	
	if(language != NULL) gtk_source_buffer_set_language (m_sBuf,language);

	printf("Language name: %s\n",gtk_source_language_get_name(language));


	//m_textbuf = gtk_text_buffer_new(NULL);
	//gtk_text_buffer_set_text(m_textbuf,"hola que tall", 13);

	GtkTextIter iter;								//Iterator
	//gtk_text_buffer_get_iter_at_offset(m_textbuf,&iter,0);
	gtk_text_buffer_get_iter_at_offset(GTK_TEXT_BUFFER(m_sBuf),&iter,0);


	FILE *fin;
	fin = fopen(m_filename.c_str(),"r");
	char buffer1[2048];

	while ( fgets(buffer1,2048,fin) != NULL)
	{
		gtk_text_buffer_insert(GTK_TEXT_BUFFER(m_sBuf),&iter,buffer1,-1);

	}
	//gtk_text_buffer_insert(m_textbuf,&iter,"hola que tal",10);
	*/
};


// =========================== GET SIZE (W) ================================= //
int  iText::get_width()
{
	return get_screen_height() - 200; 	
}

// =========================== GET SIZE (H) ================================= //
int  iText::get_height()
{
	return get_screen_height() - 160;
};

// ============================ DRAW TEXT ================================= //
void iText::draw_file_text(GtkContainer * container)
{
	GtkWidget *scwin = gtk_scrolled_window_new(NULL,NULL);
    //GtkWidget *text  = gtk_text_view_new_with_buffer(m_textbuf);
	GtkWidget *sView = gtk_source_view_new_with_buffer(m_sBuf);
	
	
	//Set monospace font to sourceView
	PangoFontDescription *font_desc;
	font_desc = pango_font_description_from_string("monospace 9");
	gtk_widget_modify_font(sView, font_desc);
	pango_font_description_free(font_desc);
	
	

	GtkTextIter start;								//Iterator	
	
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW(scwin) ,GTK_POLICY_AUTOMATIC ,GTK_POLICY_AUTOMATIC );

	/*Better view if source language*/
	if(gtk_source_buffer_get_language(m_sBuf) != NULL)
	{
		gtk_source_view_set_auto_indent				( GTK_SOURCE_VIEW(sView), true );
		gtk_source_view_set_show_line_numbers  		( GTK_SOURCE_VIEW(sView), true );
		gtk_source_view_set_tab_width       		( GTK_SOURCE_VIEW(sView),  4    );
		gtk_source_view_set_highlight_current_line 	( GTK_SOURCE_VIEW(sView), true );
	}
	else
	{
		gtk_text_view_set_left_margin  (GTK_TEXT_VIEW (sView), 10);
	}

	/*To get the interator at the start and the end of the buffer*/
	//FIXME:
	//gtk_text_buffer_get_start_iter 		( GTK_TEXT_BUFFER(m_sBuf), &start);
	//gtk_text_view_scroll_to_iter       	( GTK_TEXT_VIEW(sView),    &start, 0.0,  false,  0.5,  0.5 );


	gtk_container_add ( GTK_CONTAINER(scwin)     ,sView  );
    gtk_container_add ( GTK_CONTAINER(container) ,scwin );

    gtk_widget_set_uposition( scwin, SHADOW_WIDTH+1, SHADOW_WIDTH + HEADER_HEIGHT);
    gtk_widget_set_usize	( scwin, get_width()-2,  get_height()-25);			//FIXME: Why this -25?
    gtk_widget_show			( scwin );
    //gtk_widget_show			( text  );										//OBSOLETE
    gtk_widget_show			( sView  );
    
};

// ========================= DRAW FILE INFO ===================== //
void iText::draw_file_info(GtkContainer * container)
{
	draw_properties ( container, get_file_info_string(), 25 + SHADOW_WIDTH , get_height() + SHADOW_WIDTH + HEADER_HEIGHT);
}

// ========================= DRAW ===================== //
// Virtual function that draws what plugin wants
void iText::draw( GtkContainer * container )
{
	draw_file_text	( GTK_CONTAINER(container ));
	draw_file_info	( GTK_CONTAINER(container ));
}
